# -*- coding: utf-8 -*-
from copyreg import constructor
import os
import sys
import shutil
from os.path import join
import json

import yaml

from helpers import constants as C

v_files = {}

errorcount = 0

def load_files(virtualfiles : str) -> bool:
    if os.path.exists(virtualfiles):
        with open(virtualfiles, 'r') as json_file:
            global v_files
            v_files = json.load(json_file)

        return True
    else:
        print("Virtual files not found!")
        return False

def get_virtual_files() -> dict:
    return v_files

def get_virtual_files_with_path(target_path) -> dict:
    v_return_files = {'fileList' : []}
    for v_file in v_files['fileList']:
        if v_file['src']['path'].find(target_path) > -1:
            v_return_files['fileList'].append(v_file)

    return v_return_files

def update_dic_config(dic_config : dict) -> dict:
    if 'uml_inpath' in dic_config :
        dic_config['uml_inpath'] = update_path_for_virtual_files(dic_config['uml_inpath'])
    if 'adoc_outpath' in dic_config:
        dic_config['adoc_outpath'] = update_path_for_virtual_files(dic_config['adoc_outpath'])
    if 'source_outpath' in dic_config:
        dic_config['source_outpath'] = update_path_for_virtual_files(dic_config['source_outpath'])
    if 'plantuml_jar' in dic_config:
        dic_config['plantuml_jar'] = update_path_for_virtual_files(dic_config['plantuml_jar'])
    if 'png_outpath' in dic_config:
        dic_config['png_outpath'] = update_path_for_virtual_files(dic_config['png_outpath'])

    return dic_config

def update_path_for_virtual_files(in_path : str) -> str:
    path_elements = in_path.split("/")
    index = path_elements.index(C.ANTORA_START_FOLDER)
    out_path = "/".join(path_elements[index:])
    return out_path